#!/usr/bin/env python
#-*- coding:utf-8 -*-

import pygtk
pygtk.require("2.0")
import gtk

class CLabel(gtk.Label):
    """
        Markup on and left align label
    """
    def __init__(self, s=None):
        gtk.Label.__init__(self, s)
        self.set_use_markup(True)
        self.set_alignment(0, 0)


class SettingDialog(gtk.Dialog):
    """
        Setting Dialog
    """
    def __init__(self, parent, setting):
        gtk.Dialog.__init__(
                self,
                "Y901x の設定", 
                parent,
                gtk.DIALOG_MODAL,
                (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT, gtk.STOCK_OK, gtk.RESPONSE_ACCEPT)
            )
        # Create GtkNotebook and tab label
        note = gtk.Notebook()
        page = []
        tab_list = ("全般", "表示", "リスト")
        for i in range(len(tab_list)):
            v = gtk.VBox()
            v.set_border_width(10)
            page.append(v)
            note.append_page(page[i], gtk.Label(tab_list[i]))
        # page[0]
        l01 = CLabel("<b>全体的な設定</b>")
        page[0].pack_start(l01, False)
        self.cbox_pos = gtk.CheckButton("終了時の位置を記憶復元する")
        self.cbox_pos.set_active(setting.position)
        page[0].pack_start(self.cbox_pos, False)
        self.cbox_esc = gtk.CheckButton("Esc で終了する")
        self.cbox_esc.set_active(setting.esc_exit)
        page[0].pack_start(self.cbox_esc, False)
        self.cbox_memrep = gtk.CheckButton("リピート状態を記憶する")
        self.cbox_memrep.set_active(setting.mem_rep)
        page[0].pack_start(self.cbox_memrep, False)
        self.cbox_memaspect = gtk.CheckButton("アスペクト比状態を記憶する")
        self.cbox_memaspect.set_active(setting.mem_aspect)
        page[0].pack_start(self.cbox_memaspect, False)
        self.cbox_loop = gtk.CheckButton("すべてリピートは最後の次は先頭へ")
        self.cbox_loop.set_active(setting.endressloop)
        page[0].pack_start(self.cbox_loop, False)
        #
        self.cbox_size = gtk.CheckButton("起動時のサイズを以下に固定する")
        self.cbox_size.set_active(setting.init_size_on)
        sz = ["win","x1.0","x2.0","x3.0","x0.5","x1.5","x2.5","set1","set2","set3"]
        self.combo_size = gtk.combo_box_new_text()
        for s in sz:
            self.combo_size.append_text(s)
        self.combo_size.set_active(setting.init_size_val)
        hb1 = gtk.HBox()
        hb1.pack_start(self.cbox_size, False)
        hb1.pack_end(self.combo_size, False)
        page[0].pack_start(hb1, False)
        #
        l02 = CLabel("マウスジェスチャ感度")
        self.sb_mouse = gtk.SpinButton(gtk.Adjustment(0.0, 0.0, 10000.0, 1.0, 10.0, 0.0))
        self.sb_mouse.set_value(setting.severity)
        hb2 = gtk.HBox()
        hb2.pack_start(l02, False)
        hb2.pack_end(self.sb_mouse, False)
        page[0].pack_start(hb2, False)
        #
        # page[1]
        l11 = CLabel("<b>set size の指定</b>")
        page[1].pack_start(l11, False)
        tb = gtk.Table(3, 4)
        self.sb = []
        for i in range(6):
            self.sb.append(gtk.SpinButton(gtk.Adjustment(0.0, 0.0, 10000.0, 1.0, 10.0, 0.0)))
        self.sb[0].set_value(setting.set_size[0][0])
        self.sb[1].set_value(setting.set_size[0][1])
        self.sb[2].set_value(setting.set_size[1][0])
        self.sb[3].set_value(setting.set_size[1][1])
        self.sb[4].set_value(setting.set_size[2][0])
        self.sb[5].set_value(setting.set_size[2][1])
        table_label = ("width", "height", "set1", "set2", "set3")
        tb.attach(gtk.Label(table_label[0]),1,2,0,1)
        tb.attach(gtk.Label(table_label[1]),2,3,0,1)
        tb.attach(gtk.Label(table_label[2]),0,1,1,2)
        tb.attach(gtk.Label(table_label[3]),0,1,2,3)
        tb.attach(gtk.Label(table_label[4]),0,1,3,4)
        tb.attach(self.sb[0],1,2,1,2)
        tb.attach(self.sb[1],2,3,1,2)
        tb.attach(self.sb[2],1,2,2,3)
        tb.attach(self.sb[3],2,3,2,3)
        tb.attach(self.sb[4],1,2,3,4)
        tb.attach(self.sb[5],2,3,3,4)
        page[1].pack_start(tb, False)
        l12 = CLabel("<b>カスタムアスペクト比の指定</b>")
        self.entry_aspect = gtk.Entry()
        aspect_text = "%d:%d" % (setting.aspect_rate[0], setting.aspect_rate[1])
        self.entry_aspect.set_text(aspect_text)
        page[1].pack_start(l12, False)
        page[1].pack_start(self.entry_aspect, False)
        #
        # page[2]
        l21 = CLabel("<b>リストアップ MIME Type の設定</b>")
        page[2].pack_start(l21, False)
        l22 = CLabel('<span color="darkgreen">表示する MIME Type を改行で区切って指定</span>')
        page[2].pack_start(l22, False)
        adjustment = gtk.Adjustment()
        sw = gtk.ScrolledWindow(adjustment)
        sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
        mimebox = gtk.TextView()
        self.mimebuf = mimebox.get_buffer()
        self.mimebuf.set_text(setting.mimes.replace("|", "\n"))
        sw.add(mimebox)
        page[2].pack_start(sw)
        # pack main
        self.vbox.pack_start(note)
        self.show_all()

if __name__ == "__main__":
    # Unconscientious debug
    import y901main
    y901main.main()
